<?php
include_spip("inc/config");
include_spip("inc/refresher_functions");

// How many URls do we try to refresh every refresher pass?
define('_RECALCUL_PROCESS_NB',20);
// How many URLs can we try to refresh in parallel (multi-curl)?
define('_RECALCUL_PARALLEL_NB',2);
// How many URls do we try to refresh every warmup pass?
define('_WARMUP_PROCESS_NB',20);
// How many URLs can we try to refresh in parallel (multi-curl) in the warmup?
define('_WARMUP_PARALLEL_NB',2);

// what server load do we need to reach to pause the refresher?
define('_REFRESHER_MAX_LOAD',3);
// How many instant Mysql processes do we consider high enough to pause the refresher?
define('_REFRESHER_MAX_SQL_PROCESSES',25);
// How long can the refresher queue process URLs before timeout, in seconds?
define('_REFRESHER_MAX_TIME',80);

$method = lire_config('refresher/refresher_method');
if($method == 'push') define('_REFRESHER_METHOD','push');
else  define('_REFRESHER_METHOD','pull');

// what type of objects do we intercept to save URIs in dictionary?
$GLOBALS['refresher_objets'] = array('home', 'document', 'article', 'rubrique', 'mot', 'auteur');
// what parameters are forbidden and will prevent us from saving the URL if found? (pagination variable, for instance)
$GLOBALS['refresher_forbidden_params'] = array();
// what is the homepage template?
$GLOBALS['refresher_home_template'] = 'sommaire';
// list all templates that we do not save in dictionary
$GLOBALS['refresher_squelettes_ignores'] = array('404');
// can a page have more than one object as parameter? For instance url_propres fetches the id_rubrique on an article page. We don't want to save that info
$GLOBALS['multiple_params'] = false;

// we stop invalidating the whole cache when there's an update (basic SPIP feature)
$GLOBALS['derniere_modif_invalide'] = false;

// in case the recalcul is in POST form we turn it into GET to notice SPIP. This is a refresh.
if(isset($_POST["var_mode"]) && $_POST["var_mode"]=="calcul"){
	$_SERVER['REQUEST_METHOD']="GET";
	$_GET["var_mode"] = "calcul";
	if(!defined('_VAR_MODE')) define('_VAR_MODE', 'calcul');
	spip_log("calcul (PUSH) ".$GLOBALS['meta']['adresse_site'].$GLOBALS['REQUEST_URI'], 'refresher');
}

refresher_test();

//if($_GET['page'] != 'login' && $_GET['action'] != 'divers'){
//	echo "<a href='yoyo-".$_SERVER['REQUEST_URI']."'>toto</a>";
//}

// exemple of a pipeline for customizing an invalidation : editing an article
// NOTE: all URLs given must be without the domain. 
// i.e for http://www.mysite.com/mypath/mypage.html we only give 'mypath/mypage.html'
/*
function after_refresh_objet_modifier_article($urls, $id_article, $arr){
	// only do it if article already published online
	if(article_is_published($id_article) == 1){
		// fetch pages using this article as main object
		add_object_urls($urls, $id_article, 'article');
	}
	return $urls;
}
*/

/* examples of functions we can use:
- after_refresh_objet_modifier_article -> editing an article
- after_refresh_objet_instituer_article -> publishing/unpublishing an article
- after_refresh_lien_delete_document_article
- after_refresh_lien_insert_document_article
- after_refresh_lien_delete_mot_article
- after_refresh_lien_insert_mot_article
- after_refresh_objet_modifier_mot
... and probably more. You might want to try other combinations or objects, it might work!
*/

?>