<?php

if (!defined("_ECRIRE_INC_VERSION")) return;

function action_refresher_dist() {
	include_spip('inc/autoriser');
	if(autoriser('configurer')){
		$action = _request("refresher_action");
		
		switch ($action) {
	  	case "vider_refresher":
		  	include_spip("inc/queue");
		  	sql_delete('refresher_queue', 'date IS NOT NULL');
	    	spip_log("Attempt to manually delete all URLs from refresher_queue", 'refresher');
	    	break;
	    case "delete_cache_cdn":
	    	include_spip("inc/refresher_functions");
	    	$url_to_delete = _request("url_to_delete");
	    	spip_log("Attempt to manually refresh URL ".$url_to_delete, 'refresher');
	    	refresh_url($url_to_delete);
	    	break;
	    case "remove_spip_cache_period":
	    	include_spip("inc/refresher_functions");
	    	$from = _request('date_jour_from')." "._request('date_heure_from');
	    	$to = _request('date_jour_to')." "._request('date_heure_to');
				spip_log("Attempt to manually delete cache files from ".$from." to ".$to, 'refresher');
				$date_obj_from = date_create_from_format('Y-m-d H:i', $from);
				$date_from = date_format($date_obj_from, 'U');
				$date_obj_to = date_create_from_format('Y-m-d H:i', $to);
				$date_to = date_format($date_obj_to, 'U');
				$n = 0;
				clean_cache_folder($_SERVER['DOCUMENT_ROOT'].'/'._DIR_CACHE, $date_from, $date_to, $n);
				break;
			case "refresh_template":
	    	$skels = _request('squelettes');
	    	$squelette_names = array();
	    	if(is_array($skels)){
	    		foreach($skels as $skel) $squelette_names[] = sql_quote($skel);
	    	}
	    	if(sizeof($squelette_names) > 0){
		    	if(_REFRESHER_METHOD == 'push'){
		    		$res = sql_select("uri, squelette", "refresher_urls", "squelette in(".implode(',', $squelette_names).")");
		    		while($row = sql_fetch($res)) sql_insertq("refresher_queue", array("uri" => $row["uri"], "date" => "NOW()", "priorite" => 2, "objet" => "squelette|".$row['squelette']));
		    	}
		  		else{
		  			sql_updateq("refresher_urls", array("statut" => "pull"), "squelette in(".implode(',', $squelette_names).")");
		  		}
		  	}
				break;
			case "refresh_object":
	    	$objet = _request('objet');
	    	$id_objet = _request('id_objet');
	    	if(_REFRESHER_METHOD == 'push'){
	    		$res = sql_select("uri", "refresher_urls", "objet=".sql_quote($objet)." and id_objet=".intval($id_objet));
	    		while($row = sql_fetch($res)) sql_insertq("refresher_queue", array("uri" => $row["uri"], "date" => "NOW()", "priorite" => 2, "objet" => "objet|".$objet."|".$id_objet));
	    	}
	  		else sql_updateq("refresher_urls", array("statut" => "pull"), "objet=".sql_quote($objet)." and id_objet=".intval($id_objet));
				break;
			case "add_url_cron":
	    	$url = _request('url');
	    	$frequence = _request('frequence');
				spip_log("Attempt to add cron job ".$url." with a frequency of ".$frequence, 'refresher');
				if($url != '' && is_numeric($frequence)){
					$res = sql_select("url", "refresher_cron", "url=".sql_quote($url), "", "", 1);
					if(sql_count($res) == 0) sql_insertq("refresher_cron", array("url" => $url, "frequence" => intval($frequence), "last_hit" => 'NOW()'));
					else sql_updateq("refresher_cron", array("frequence" => intval($frequence)), "url=".sql_quote($url));
				}
				break;
			case "remove_url_cron":
	    	$urls = _request('urls');
				if(is_array($urls)){
					foreach($urls as $url){ 
						spip_log("Attempt to remove cron job ".$url, 'refresher');
						sql_delete("refresher_cron", "url=".sql_quote($url));
					}
				}
				break;
			case "start_warmup":
	    	ecrire_config("/meta/refresher/warmup_start_time", time());
				sql_delete("refresher_warmup", "1");
				sql_insertq("refresher_warmup", array("uri" => "", "statut" => "pending"));
				break;
			case "vider_warmup":
	    	ecrire_config("/meta/refresher/warmup_start_time", 0);
				spip_query("TRUNCATE TABLE refresher_warmup");
				break;
		}
	}
	if(isset($n)) header("Location: /ecrire/?exec=configurer_refresher&removed=".$n);
	else header("Location: /ecrire/?exec=configurer_refresher");
	die('You will be redirected soon...');
}

?>