<?php

function refresher_test(){
	if(isset($GLOBALS['refresher_objets']) && is_array($GLOBALS['refresher_objets'])){
		include_spip('inc/urls');
		include_spip('base/abstract_sql');
		$url_requested = nettoyer_uri();
		if(substr($url_requested, 0, 1) == '/') $url_requested = substr($url_requested, 1);
		list ($url_requested) = explode('#', $url_requested);
		// we dont want to save query string variations... maybe some other do?
		list($url_requested) = explode('?', $url_requested);
		list($fond, $contexte, $url_redirect) = urls_decoder_url($url_requested);
		// if url redirects, we remove it from dictionary and skip the rest
		if($url_redirect != ''){ 
			sql_delete("refresher_urls", "uri=".sql_quote($url_redirect));
			return;
		}
		// check if there is a forbidden parameter in the URL
		foreach($GLOBALS['refresher_forbidden_params'] as $param) if(isset($_GET[$param])) return;
		if($fond == '' && isset($_GET['page'])){ 
			$fond = $_GET['page'];
			$contexte = $_GET;
		}
		/* we don't save forbidden templates */
		if(in_array($fond, $GLOBALS['refresher_squelettes_ignores'])) return;
		$found = false;
		if($fond == $GLOBALS['refresher_home_template']){ 
			$contexte['objet'] = 'home';
			$contexte['id_objet'] = 0;
		}
		foreach($GLOBALS['refresher_objets'] as $objet){
			if((isset($contexte['id_'.$objet]) || isset($contexte[$objet])) && ($GLOBALS['multiple_params'] || (!$GLOBALS['multiple_params'] && !$found))){
				$found = true;
				if(isset($contexte['id_'.$objet])) $id_objet = $contexte['id_'.$objet];
				else $id_objet = $contexte[$objet];
				if(is_array($id_objet)) $id_objet = implode("|", $id_objet);
				$res = sql_select("statut", "refresher_urls", "uri=".sql_quote($url_requested)." and objet=".sql_quote($objet)." and id_objet=".sql_quote($id_objet), "", "", 1);
				if($row = sql_fetch($res)){
					// is the URL OK or does it need a pull?
					if($row['statut'] == 'pull' && !defined('_VAR_MODE')) define('_VAR_MODE', 'calcul');
					if(defined('_VAR_MODE') && (_VAR_MODE == 'calcul' || _VAR_MODE == 'recalcul')){ 
						sql_updateq('refresher_urls', array('statut' => 'OK', 'maj' => 'NOW()', 'squelette' => $fond), "uri=".sql_quote($url_requested));
					}
				}
				else{
					//if(!defined('_VAR_MODE')) define('_VAR_MODE', 'calcul');
					sql_insertq('refresher_urls', array('uri' => $url_requested, 'objet' => $objet, 'id_objet' => $id_objet, 'squelette' => $fond, 'statut' => 'OK', 'maj' => 'NOW()'));
				}
			}
		}
	}
}

// function to refresh pages when SPIP object is updated
function refresh($type, $arr, $from_cron = false){
	include_spip("inc/queue");
	
	$champs = $arr["data"];
	$args = $arr["args"];
	$id_objet = $date = 0;
	$local_path = $_SERVER['DOCUMENT_ROOT']."/tmp/refresher";
	if(!file_exists($local_path)) mkdir($local_path, 0775);
	
	$urls = array('push' => array(), 'pull' => array());
	if($type == "lien"){
		$objet_source = $args['objet_source'];
		$id_objet_source = $args['id_objet_source'];
		$objet = $args['objet'];
		$id_objet = $args['id_objet'];
		$action = $args['action'];
		
		// system to avoid working on the same object from different sources (like parallel documents uploads)
		if(file_exists($local_path."/".$objet."_".$id_objet)){ 
			$ftime = filemtime($local_path."/".$objet."_".$id_objet);
			if((time() - $ftime) < (60)) return;
		}
		touch($local_path."/".$objet."_".$id_objet);
		
		if($objet == 'article') $date = article_is_published($id_objet);
		$f = "refresh_lien_".$action."_".$objet_source."_".$objet;
		$f2 = "after_refresh_lien_".$action."_".$objet_source."_".$objet;
		
		// new system we try to push the process in the job_queue
		if((function_exists($pf) || function_exists($f)) && !$from_cron){
			// custom fix: we remove the id_document so the parameters are all the same for each docs of the same article
			// this way the job_queue wont accumulate jobs from different documents but for the same article
			if($objet_source == "document") unset($arr['args']['id_objet_source']);
			include_spip("inc/queue");
			job_queue_add('refresh',"Build refresher URL list (".$id_objet." | ".$objet.")", array($type,$arr,true), "inc/refresher_functions", TRUE);
			return;
		}
		// system to avoid working on the same object from different sources (like parallel documents uploads)
		if(file_exists($local_path."/".$objet."_".$id_objet)){ 
			$ftime = filemtime($local_path."/".$objet."_".$id_objet);
			if((time() - $ftime) < (60)) return;
		}
		touch($local_path."/".$objet."_".$id_objet);
		if(function_exists($f)) $urls = $f($urls, $id_objet_source, $id_objet, $arr);
		if(function_exists($f2)) $urls = $f2($urls, $id_objet_source, $id_objet, $arr);
	}
	if($type == 'objet'){
		if(isset($args['type'])) $objet = $args['type'];
		//WARNING!!! UGLY! need to find the function that gets object type from table name
		else $objet = substr(str_replace("spip_", "", $args['table']), 0, -1);
		$id_objet = $args['id_objet'];
		$action = $args['action'];
		
		// if this is about publishing an article, we set the refresh date to the publish date
		if($action == 'instituer' && $objet == 'article'){ 
			$date = article_is_published($id_objet);
			// if action is 'instituer' but no old status given as parameter, it is a regular article fields edition
			if(!isset($args['statut_ancien'])) $action = 'modifier';
		}
		// forum posted : we refresh immediately - a direct pull is enough
		if($args['table'] == 'spip_forum' && $objet == 'article'){
			$url_objet = generer_url_entite($id_objet, $objet, '', '', true);
			sql_updateq('refresher_urls', array('statut' => 'pull'), "uri=".sql_quote($url_objet));
		}
		
		// system to avoid working on the same object from different sources (like parallel documents uploads)
		if(file_exists($local_path."/".$objet."_".$id_objet)){ 
			$ftime = filemtime($local_path."/".$objet."_".$id_objet);
			if((time() - $ftime) < (60)) return;
		}
		touch($local_path."/".$objet."_".$id_objet);
		$f = "refresh_objet_".$action."_".$objet;
		$f2 = "after_refresh_objet_".$action."_".$objet;
		
		// new system we try to push the process in the job_queue
		if(function_exists($f) && !$from_cron){
			include_spip("inc/queue");
			$res2 = sql_allfetsel("id_job","spip_jobs","descriptif='Build refresher URL list (".$id_objet." | ".$objet.")'");
			if(is_array($res2)){
				foreach ($res2 as $row2)
					queue_remove_job($row2['id_job'],0);
			}
			job_queue_add('refresh',"Build refresher URL list (".$id_objet." | ".$objet.")", array($type,$arr,true), "inc/refresher_functions", TRUE);
			return;
		}
		// system to avoid working on the same object from different sources (like parallel documents uploads)
		if(file_exists($local_path."/".$objet."_".$id_objet)){ 
			$ftime = filemtime($local_path."/".$objet."_".$id_objet);
			if((time() - $ftime) < (60)) return;
		}
		touch($local_path."/".$objet."_".$id_objet);
		if(function_exists($f)) $urls = $f($urls, $id_objet, $arr);
		if(function_exists($f2)) $urls = $f2($urls, $id_objet, $arr);
	}
	
	if(sizeof($urls['push']) == 0 && sizeof($urls['pull']) == 0) return;
	
	if(isset($objet) && isset($id_objet)) $obj = $objet.'|'.$id_objet.'|'.$action;
	else $obj = '';
	
	//we delete potential existing jobs from the same origin
	if($obj != ''){
		sql_delete('refresher_queue', 'objet='.sql_quote($obj));
	}
	
	if(sizeof($urls['push']) == 0 && sizeof($urls['pull']) == 0){ 
		if(isset($id_objet)) unlink($local_path."/".$objet."_".$id_objet);
		return;
	}
	
	// if any doubles we get rid of them, no need to refresh the same URL twice
	$urls['push'] = array_unique($urls['push'], SORT_REGULAR);
	$urls['pull'] = array_unique($urls['pull'], SORT_REGULAR);
	
	// if date between 0 and now, we set to now (an old past date could be a problem in job queue)
	if($date < time() && $date >= 0) $date = time();
	$sql_date = date("Y-m-d H:i:s", $date);
	
	/* first take care of pull system */
	if(sizeof($urls['pull']) > 0){
		if($date < 0){ 
			traiter_pull($urls['pull']);
		}
		// else we put task in job queue
		else{
			foreach($urls['pull'] as $pull_url){
				sql_insertq('refresher_queue',array('uri' => $url, 'type' => 'pull', 'date' => $sql_date, 'objet' => $obj));	
			}
		}
	}
	
	/* Now we take care of push system */
	if(sizeof($urls['push']) > 0){
		foreach($urls['push'] as $push_urls){
			if(!is_array($push_urls)) $push_urls = array($push_urls);
			foreach($push_urls as $url){ 
				sql_insertq('refresher_queue',array('uri' => $url, 'type' => 'push', 'date' => $sql_date, 'objet' => $obj));
			}
		}
	}
	if(isset($id_objet)) unlink($local_path."/".$objet."_".$id_objet);
	return;
}

function refresh_objet_modifier_article($urls, $id_article, $arr){
	// regular edition of article (fields update)
	// only do it if article already published online
	if(article_is_published($id_article) == 1){
		// refresh article
		add_object_urls($urls, $id_article, 'article');	
		// refresh homepage
		add_object_urls($urls, 0, 'home');	
		// get rubrique of article and all branch
		$res = sql_select("id_rubrique", "spip_articles", "id_article=".intval($id_article), "", "", 1);
		if($row = sql_fetch($res)){ 
			$id_rubrique = $row['id_rubrique'];
			while($id_rubrique != 0){
				add_object_urls($urls, $id_rubrique, 'rubrique');	
				$res_rub = sql_select("id_parent", "spip_rubriques", "id_rubrique=".intval($id_rubrique));
				if($row_rub = sql_fetch($res_rub)) $id_rubrique = $row_rub["id_parent"];
				else $id_rubrique = 0;
			}
		}
		// get keywords
		$res = sql_select("id_mot", "spip_mots_liens", "id_objet=".intval($id_article)." and objet='article'");
		while($row = sql_fetch($res)) add_object_urls($urls, $row['id_mot'], 'mot');	
		// get authors
		$res = sql_select("id_auteur", "spip_auteurs_liens", "id_objet=".intval($id_article)." and objet='article'");
		while($row = sql_fetch($res)) add_object_urls($urls, $row['id_auteur'], 'auteur');	
	}
	return $urls;
}

function refresh_objet_instituer_article($urls, $id_article, $arr){
	$champs = $arr["data"];
	$args = $arr["args"];
	// refresh when set status to published or if we unpublish or date of publication changed
	if(($champs['statut'] == 'publie' && $args['action'] == 'instituer') || $champs['statut_ancien'] == 'publie'){
		// if we unset published status but article was not online yet there is nothing to refresh
		if($champs['statut_ancien'] == 'publie' && article_is_published($args['id_objet']) != 1) return $urls;
		// refresh homepage
		add_object_urls($urls, 0, 'home');	
		// get rubrique of article and all branch
		$res = sql_select("id_rubrique", "spip_articles", "id_article=".intval($id_article), "", "", 1);
		if($row = sql_fetch($res)){ 
			$id_rubrique = $row['id_rubrique'];
			while($id_rubrique != 0){
				add_object_urls($urls, $id_rubrique, 'rubrique');	
				$res_rub = sql_select("id_parent", "spip_rubriques", "id_rubrique=".intval($id_rubrique));
				if($row_rub = sql_fetch($res_rub)) $id_rubrique = $row_rub["id_parent"];
				else $id_rubrique = 0;
			}
		}
		// get authors
		$res = sql_select("id_auteur", "spip_auteurs_liens", "id_objet=".intval($id_article)." and objet='article'");
		while($row = sql_fetch($res)) add_object_urls($urls, $row['id_auteur'], 'auteur');	
		// get keywords
		$res = sql_select("id_mot", "spip_mots_liens", "id_objet=".intval($id_article)." and objet='article'");
		while($row = sql_fetch($res)) add_object_urls($urls, $row['id_mot'], 'mot');	
	}
	return $urls;
}

function refresh_lien_delete_mot_article($urls, $id_mot, $id_article, $arr){
	return refresh_lien_mot_article($urls, $id_mot, $id_article, $arr);
}
function refresh_lien_insert_mot_article($urls, $id_mot, $id_article, $arr){
	return refresh_lien_mot_article($urls, $id_mot, $id_article, $arr);
}
function refresh_lien_mot_article($urls, $id_mot, $id_article, $arr){
	// get id_groupe
	$res = sql_select("id_groupe", "spip_mots", "id_mot=".intval($id_mot));
	if($row = sql_fetch($res)){
		$id_groupe = $row['id_groupe'];
		// refresh article
		add_object_urls($urls, $id_article, 'article');
		// refresh homepage
		add_object_urls($urls, 0, 'home');	
		// get rubrique of article and all branch
		$res = sql_select("id_rubrique", "spip_articles", "id_article=".intval($id_article), "", "", 1);
		if($row = sql_fetch($res)){ 
			$id_rubrique = $row['id_rubrique'];
			while($id_rubrique != 0){
				add_object_urls($urls, $id_rubrique, 'rubrique');
				$res_rub = sql_select("id_parent", "spip_rubriques", "id_rubrique=".intval($id_rubrique));
				if($row_rub = sql_fetch($res_rub)) $id_rubrique = $row_rub["id_parent"];
				else $id_rubrique = 0;
			}
		}
		// refresh mot
		add_object_urls($urls, $id_mot, 'mot');
		// get authors
		$res = sql_select("id_auteur", "spip_auteurs_liens", "id_objet=".intval($id_article)." and objet='article'");
		while($row = sql_fetch($res)) add_object_urls($urls, $row['id_auteur'], 'auteur');
	}
	return $urls;
}

function refresh_lien_delete_document_article($urls, $id_document, $id_article, $arr){
	return refresh_lien_document_article($urls, $id_document, $id_article, $arr);
}
function refresh_lien_insert_document_article($urls, $id_document, $id_article, $arr){
	return refresh_lien_document_article($urls, $id_document, $id_article, $arr);
}
function refresh_lien_document_article($urls, $id_document, $id_article, $arr){
	// check if article is published
	if(article_is_published($id_article) == 1){
		// refresh article
		add_object_urls($urls, $id_article, 'article');
		// refresh homepage
		add_object_urls($urls, 0, 'home');	
		// get rubrique of article and all branch
		$res = sql_select("id_rubrique", "spip_articles", "id_article=".intval($id_article), "", "", 1);
		if($row = sql_fetch($res)){ 
			$id_rubrique = $row['id_rubrique'];
			while($id_rubrique != 0){
				add_object_urls($urls, $id_rubrique, 'rubrique');
				$res_rub = sql_select("id_parent", "spip_rubriques", "id_rubrique=".intval($id_rubrique));
				if($row_rub = sql_fetch($res_rub)) $id_rubrique = $row_rub["id_parent"];
				else $id_rubrique = 0;
			}
		}
		// any other document page of this article
		$res = sql_select("id_document", "spip_documents_liens", "objet='article' and id_objet=".intval($id_article));
		while($row = sql_fetch($res)){ 
			add_object_urls($urls, $row['id_document'], 'document');
		}
		// get keywords
		$res = sql_select("id_mot", "spip_mots_liens", "id_objet=".intval($id_article)." and objet='article'");
		while($row = sql_fetch($res)) add_object_urls($urls, $row['id_mot'], 'mot');
		// get authors
		$res = sql_select("id_auteur", "spip_auteurs_liens", "id_objet=".intval($id_article)." and objet='article'");
		while($row = sql_fetch($res)) add_object_urls($urls, $row['id_auteur'], 'auteur');
	}	
	return $urls;
}

function refresh_lien_delete_document_rubrique($urls, $id_document, $id_rubrique, $arr){
	return refresh_lien_document_rubrique($urls, $id_document, $id_rubrique, $arr);
}
function refresh_lien_insert_document_rubrique($urls, $id_document, $id_rubrique, $arr){
	return refresh_lien_document_rubrique($urls, $id_document, $id_rubrique, $arr);
}
function refresh_lien_document_rubrique($urls, $id_document, $id_rubrique, $arr){
	add_object_urls($urls, $id_rubrique, 'rubrique');
	return $urls;
}

function refresh_lien_delete_document_mot($urls, $id_document, $id_mot, $arr){
	return refresh_lien_document_article($urls, $id_document, $id_mot, $arr);
}
function refresh_lien_insert_document_mot($urls, $id_document, $id_mot, $arr){
	return refresh_lien_document_article($urls, $id_document, $id_mot, $arr);
}
function refresh_lien_document_mot($urls, $id_document, $id_mot, $arr){
	add_object_urls($urls, $id_mot, 'mot');
	return $urls;
}

function refresh_objet_modifier_mot($urls, $id_mot, $arr){
	// refresh keyword page
	add_object_urls($urls, $id_mot, 'mot');
	// refresh home
	add_object_urls($urls, 0, 'home');	
	// if title change we refresh objects using this keyword
	if(isset($arr['data']['titre'])){
		$res = sql_select("id_objet, objet", "spip_mots_liens", "id_mot=".intval($id_mot));
		while($row = sql_fetch($res)){
			// only if article is online or other object
			if(($row['objet'] == 'article' && article_is_published($row['id_objet']) == 1) || $row['id_objet'] != 'article') add_object_urls($urls, $row['id_objet'], $row['objet']);
		}
	}
	
	return $urls;
}

function refresh_objet_modifier_rubrique($urls, $id_rubrique, $arr){
	// refresh rubrique page
	add_object_urls($urls, $id_rubrique, 'rubrique');
	// refresh home
	add_object_urls($urls, 0, 'home');	
	// if title change we refresh articles in this section and parent section
	if(isset($arr['data']['titre'])){
		$res = sql_select("id_article", "spip_articles", "id_rubrique=".intval($id_rubrique));
		while($row = sql_fetch($res)){
			$id_article = $row['id_article'];
			// only if article is online
			if(article_is_published($id_article) == 1) add_object_urls($urls, $id_article, 'article');
		}
		$res = sql_select("id_parent", "spip_rubriques", "id_rubrique=".intval($id_rubrique));
		if($row = sql_fetch($res)) 
			if($row['id_parent'] != 0)
				add_object_urls($urls, $row['id_parent'], 'rubrique');
	}
	return $urls;
}


function refresh_objet_modifier_document($urls, $id_document, $arr){
	// refresh objects pages
	if(lire_config('refresher/document_modifier_article') == 'on'){
		$res = sql_select("id_objet", "spip_documents_liens", "id_document=".intval($id_document));
		while($row = sql_fetch($res)){
			if(($row['objet'] == 'article' && article_is_published($row['id_objet']) == 1) || $row['id_objet'] != 'article') add_object_urls($urls, $row['id_objet'], $row['objet']);
		}	
	}
	// refresh document page
	add_object_urls($urls, $id_document, 'document');
	return $urls;
}

// traiter_pull : we take care of pull invalidations
function traiter_pull($pull_list){
	$url_list = array();
	foreach($pull_list as $uri){	
		array_push($url_list, $GLOBALS['meta']['adresse_site'].'/'.$uri);
		sql_updateq('refresher_urls', array('statut' => 'pull'), "uri=".sql_quote($uri));
	}
	if(sizeof($url_list) > 0) invalider_url_cdn($url_list);
}

// we take care of push invalidations
// extra_params are used as http headers in CURL calls
// if source is the warmup, we will return all links found in the pages
function refresh_url($urls, $extra_params = array(), $source = ''){
	if(!is_array($urls)) $urls = array($urls);
	$links = array();
	$n_calls = 0;
	$handles = array();
	$result_urls = array();
	$result = array();
	
	$mh = curl_multi_init();
	foreach($urls as $url){	
		if(substr($url, 0, 1) == '/') $url = substr($url, 1);
		if(strpos($url, $GLOBALS['meta']['adresse_site']) === false) $url = $GLOBALS['meta']['adresse_site'].'/'.$url;
		$result_urls[$n_calls] = $url;
		$handles[$n_calls] = curl_init();
	
		$agent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.0.3705; .NET CLR 1.1.4322)';
		$extra_post = '';
		foreach($extra_params as $key => $val){ 
			$extra_post .= "&".$key."=".$val;	
		}
		// or extra params specified as get
		if(strpos($url, "?") !== false){
			$arr = explode("?", $url);
			$url = $arr[0];
			$postvars = $arr[1];
		}
		else $postvars = 'var_mode=calcul&var_isbot=0'.$extra_post;  // POST VARIABLES TO BE SENT
		curl_setopt($handles[$n_calls], CURLOPT_POST, 1);
	  curl_setopt($handles[$n_calls], CURLOPT_POSTFIELDS, $postvars);
		curl_setopt($handles[$n_calls], CURLOPT_URL, $url);
		curl_setopt($handles[$n_calls], CURLOPT_FOLLOWLOCATION  ,1);
		curl_setopt($handles[$n_calls], CURLOPT_ENCODING , "");
		curl_setopt($handles[$n_calls], CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($handles[$n_calls], CURLOPT_RETURNTRANSFER, 1);
	  curl_setopt($handles[$n_calls], CURLOPT_CONNECTTIMEOUT, 30); 
		curl_setopt($handles[$n_calls], CURLOPT_USERAGENT, $agent);
		curl_multi_add_handle($mh, $handles[$n_calls]);
	  $n_calls++;
	}
 	if(sizeof($result_urls) >=1){
	 	// execute the handles
	  $running = null;
	  do {
	    curl_multi_exec($mh, $running);
	  } while($running > 0);
	  
	 	// get content and remove handles
	  $errors = $http_codes = array();
	  foreach($handles as $id => $c) {
	    if($source == 'warmup') warmup_find_links(curl_multi_getcontent($c), $links);
	    $error = curl_error($c);
  		$http_code   = curl_getinfo($c, CURLINFO_HTTP_CODE);
  		curl_multi_remove_handle($mh, $c);
	  }
 	}
  // all done
  curl_multi_close($mh);
	// we delete the cache in CDN for this URL if activated in backend
	invalider_url_cdn($urls);
	return $links;
}

// simply access url, useful when we we want to fetch a page to feed the CDN cache or if we start with an empty cache to save ressources
function access_url($urls, $extra_params = array(), $source = ''){
	if(!is_array($urls)) $urls = array($urls);
	$links = array();
	$n_calls = 0;
	$handles = array();
	$result_urls = array();
	$result = array();
	
	$mh = curl_multi_init();
	$agent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.0.3705; .NET CLR 1.1.4322)';
	foreach($urls as $url){
		if(substr($url, 0, 1) == '/') $url = substr($url, 1);
		if(strpos($url, $GLOBALS['meta']['adresse_site']) === false) $url = $GLOBALS['meta']['adresse_site'].'/'.$url;
		$result_urls[$n_calls] = $url;
		$handles[$n_calls] = curl_init();
		if(sizeof($extra_params) > 0){
		  $extra_post = '';
			foreach($extra_params as $key => $val){ 
				$extra_post .= "&".$key."=".$val;	
			}
		  define('POSTURL', $url);
			curl_setopt($handles[$n_calls], CURLOPT_POST, 1);
		  define('POSTVARS', substr($extra_post, 1));  // POST VARIABLES TO BE SENT
		  curl_setopt($handles[$n_calls], CURLOPT_POSTFIELDS, POSTVARS);
		}
		curl_setopt($handles[$n_calls], CURLOPT_URL, $url);
		curl_setopt($handles[$n_calls], CURLOPT_FOLLOWLOCATION  ,1);
		curl_setopt($handles[$n_calls], CURLOPT_ENCODING , "");
		curl_setopt($handles[$n_calls], CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($handles[$n_calls], CURLOPT_RETURNTRANSFER, 1);
  	curl_setopt($handles[$n_calls], CURLOPT_CONNECTTIMEOUT, 30); 
		curl_setopt($handles[$n_calls], CURLOPT_USERAGENT, $agent);
		curl_multi_add_handle($mh, $handles[$n_calls]);
	  $n_calls++;
	}
 	// execute the handles
  $running = null;
  do {
    curl_multi_exec($mh, $running);
  } while($running > 0);
  
 	// get content and remove handles
  $errors = $http_codes = array();
  foreach($handles as $id => $c) {
    if($source == 'warmup') warmup_find_links(curl_multi_getcontent($c), $links);
    $error = curl_error($c);
		$http_code   = curl_getinfo($c, CURLINFO_HTTP_CODE);
		curl_multi_remove_handle($mh, $c);
  }
 
  // all done
  curl_multi_close($mh);
  return $links;
}

function invalider_url_cdn($urls){
	if(lire_config('refresher/use_invalideur_cdn') != 'no'){
		if(!is_array($urls)) $urls = array($urls); 
		spip_log("CDN purge:".$urls[0]." to ".$urls[sizeof($urls)-1], 'refresher');
		if(lire_config('refresher/use_invalideur_cdn') == 'akamai') invalider_url_cdn_akamai($urls);
		if(lire_config('refresher/use_invalideur_cdn') == 'edgecast') invalider_url_cdn_edgecast($urls);
		if(lire_config('refresher/use_invalideur_cdn') == 'cloudflare') invalider_url_cdn_cloudflare($urls);
		if(lire_config('refresher/use_invalideur_cdn') == 'fastly') invalider_url_cdn_fastly($urls);
	}
	return;
}

function invalider_url_cdn_fastly($urls){
	if(!is_array($urls)) $urls = array($urls);
	
	$n_calls = 0;
	$handles = array();
	$result_urls = array();
	$result = array();
	
	$service_id = lire_config('refresher/fastly_service_id');
	$key = lire_config('refresher/fastly_key');
	$mh = curl_multi_init();
	
	foreach($urls as $url){
		$result_urls[$n_calls] = $url;
		$soft = false;
		if(strpos($url, '/soft-purge/') !== false){
			$soft = true;
			$url = str_replace("/soft-purge/", "/", $url);
		}
		$handles[$n_calls] = curl_init();
		if(strpos($url, '/surrogate-key/') !== false) $fastly_url = 'https://app.fastly.com/service/'.$service_id.'/purge/'.substr($url, strpos($url, '/surrogate-key/')+15);
		else $fastly_url = "https://app.fastly.com/purge/" . str_replace("http://",'', str_replace("https://",'', $url));
		if($soft) $headers = array("Fastly-Key: ".$key, "Accept: application/json", "Fastly-Soft-Purge: 1");
	  else $headers = array("Fastly-Key: ".$key, "Accept: application/json");
	  curl_setopt($handles[$n_calls], CURLOPT_URL, $fastly_url);
	  curl_setopt($handles[$n_calls], CURLOPT_CUSTOMREQUEST, "POST");
	  curl_setopt($handles[$n_calls], CURLOPT_RETURNTRANSFER, 1);
	  curl_setopt($handles[$n_calls], CURLOPT_HTTPHEADER, $headers);
	  curl_setopt($handles[$n_calls], CURLOPT_SSL_VERIFYPEER, false);
	  curl_multi_add_handle($mh, $handles[$n_calls]);
	  $n_calls++;
	}
 	if(sizeof($result_urls) >= 1){
	 	// execute the handles
	  $running = null;
	  do {
	    curl_multi_exec($mh, $running);
	  } while($running > 0);
	  
	 	// get content and remove handles
	  foreach($handles as $id => $c) {
	    $result[$id] = curl_multi_getcontent($c);
	    curl_multi_remove_handle($mh, $c);
	  }
 	}
  // all done
  curl_multi_close($mh);
 	
 	foreach($result as $k => $res){
 		spip_log($result_urls[$k].' -> '.$res, 'refresher'._LOG_INFO_IMPORTANTE);
 	}
 	
 	// if homepage we need to invalidate the homepage without ending '/'
 	// since they seem to have different caches on Fastly
 	if(in_array($GLOBALS['meta']['adresse_site'].'/', $urls)) invalider_url_cdn_fastly($GLOBALS['meta']['adresse_site']);
}

function invalider_url_cdn_cloudflare($urls){
	if(!is_array($urls)) $urls = array($urls);
	
	$token = lire_config('refresher/cloudflare_token');
	$account_email = lire_config('refresher/cloudflare_email');
	$zone_id = lire_config('refresher/cloudflare_zone_id');
	
	spip_log("about to purge on Cloudflare:".$urls[0]." to ".$urls[sizeof($urls)-1]." number of urls: ".sizeof($urls), 'refresher');
	
	// action can be set to 'remove' or 'invalidate'
	$headers = array("X-Auth-Email: ".$account_email, "X-Auth-Key: ".$token, "Content-type: application/json");
	$data = array("files" => $urls);
  $data_string = json_encode($data);
  $data_string = str_replace("\\/", '/', $data_string);
  
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_VERBOSE, 0);
  curl_setopt($ch, CURLOPT_FORBID_REUSE, true);
  curl_setopt($ch, CURLOPT_URL, "https://api.cloudflare.com/client/v4/zones/".$zone_id."/purge_cache");
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
	curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
  curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $http_result = curl_exec($ch);
  $response = json_decode($http_result);
  $error       = curl_error($ch);
  $http_code   = curl_getinfo($ch, CURLINFO_HTTP_CODE);
  curl_close($ch);
  
  if ($http_code != 200) {
      spip_log ("Something went wrong (HTTP_CODE=".$http_code."). Cloudflare purge request failed for ".$urls[0]." to ".$urls[sizeof($urls)-1].". number of urls: ".sizeof($urls)." -> ".$response->httpStatus."(".$response->title."), error:".$error,'refresher'._LOG_ERREUR);
  } else {
      spip_log ("Purge Success (Cloudflare) for:".$urls[0]." to ".$urls[sizeof($urls)-1].". number of urls: ".sizeof($urls),'refresher');
  }
}

function invalider_url_cdn_edgecast($urls, $load = false){
	if(!is_array($urls)) $urls = array($urls);
	foreach($urls as $url){	
		spip_log("about to purge on Edgecast:".$url, 'refresher');
		
		$token = lire_config('refresher/edgecast_token');     // found on the cdn admin My Settings
		$account_number = lire_config('refresher/edgecast_account');        // found on the cdn admin Top Right corner
		
	  // Build the request
	  $request_params = (object) array('MediaPath' =>  $url, 'MediaType' => 8);   // MediaType 8=small 3=large
	  $data = json_encode($request_params);
	
	  // setup the connection and call for a purge.
	  $ch = curl_init();
	  curl_setopt($ch, CURLOPT_URL, 'https://api.edgecast.com/v2/mcc/customers/'.$account_number.'/edge/purge');
	  curl_setopt($ch, CURLOPT_PORT , 443);
	  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	  curl_setopt($ch, CURLOPT_HEADER, 0);
	  curl_setopt($ch, CURLINFO_HEADER_OUT, 1);                  // For debugging
	  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	  curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);             // no caching  
	  curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);            // no caching  
	  curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
	  curl_setopt($ch, CURLOPT_POSTFIELDS,$data);
	  curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: tok:'.$token, 'Content-Type: application/json','Accept: application/json', 'Content-length: '.strlen($data), 'Host: api.edgecast.com'));
	  $head = curl_exec($ch);
	  $httpCode = curl_getinfo($ch);
	  curl_close($ch);
		
		// check if error
	  if ($httpCode['http_code'] != 200) spip_log("URL ".$url." COULD NOT be deleted from CDN cache: ERROR PURGE ", 'refresher'._LOG_ERREUR);
	  else spip_log("URL ".$url." - CDN API PURGE done", 'refresher');
		
		// now we load if it is a specific URL
		if($load && strpos($url, '*') === false){ 
			$ch = curl_init();
	  	spip_log("URL ".$url." trying load function", 'refresher');
	  	curl_setopt($ch, CURLOPT_URL, 'https://api.edgecast.com/v2/mcc/customers/'.$account_number.'/edge/load');
	  	curl_setopt($ch, CURLOPT_PORT , 443);
		  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		  curl_setopt($ch, CURLOPT_HEADER, 0);
		  curl_setopt($ch, CURLINFO_HEADER_OUT, 1);                  // For debugging
		  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		  curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);             // no caching  
		  curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);            // no caching  
		  curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
		  curl_setopt($ch, CURLOPT_POSTFIELDS,$data);
		  curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: tok:'.$token, 'Content-Type: application/json','Accept: application/json', 'Content-length: '.strlen($data), 'Host: api.edgecast.com'));
		  $head = curl_exec($ch);
		  $httpCode = curl_getinfo($ch);
		  curl_close($ch);
		  
		  // check if error
		  if ($httpCode['http_code'] != 200) spip_log("URL ".$url." COULD NOT be loaded from CDN cache: ERROR LOAD ", 'refresher'._LOG_ERREUR);
		  else spip_log("EDGECAST CDN API LOAD done for url:".$url, 'refresher');
		}
	}
	return;
}

function invalider_url_cdn_akamai($urls){ // 'pap' stands for Php Akamai Purge 
	if(!is_array($urls)) $urls = array($urls);
	
	spip_log("about to purge on Akamai:".$urls[0]." to ".$urls[sizeof($urls)-1]." number of urls: ".sizeof($urls), 'refresher');
	$user = lire_config('refresher/akamai_user');
	$password = lire_config('refresher/akamai_password');
	
	// action can be set to 'remove' or 'invalidate'
	$data = array("type" => "arl", "action" => "remove", "objects" => $urls);
  $data_string = json_encode($data);
  $data_string = str_replace("\\/", '/', $data_string);

  $ch = curl_init("https://api.ccu.akamai.com/ccu/v2/queues/default");
  curl_setopt_array($ch, array(
      curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST"),
      CURLOPT_RETURNTRANSFER => TRUE,
      CURLOPT_USERPWD => "$user:$password",
      CURLOPT_HTTPAUTH => CURLAUTH_BASIC,
      CURLOPT_POSTFIELDS => $data_string,
      CURLOPT_FOLLOWLOCATION => TRUE,
      curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Content-Length: '.strlen($data_string)))
  ));

  $response = curl_exec($ch);
  $response = json_decode($response);

  if ($response->httpStatus < 300) { // success
		spip_log ("Purge Success for:".$urls[0]." to ".$urls[sizeof($urls)-1].". number of urls: ".sizeof($urls),'refresher');
	} else {
		spip_log ("Something went wrong (1). Akamai purge request failed for ".$urls[0]." to ".$urls[sizeof($urls)-1].". number of urls: ".sizeof($urls)." -> ".$response->httpStatus."(".$response->title.")",'refresher'._LOG_ERREUR);
	}
}

// get all URLs from dictionary from a specific object
function get_urls_from_object($id_objet, $objet){
	$result = array();
	$res = sql_select("uri, squelette, id_objet, objet", "refresher_urls", "id_objet=".sql_quote($id_objet)." and (objet=".sql_quote($objet)." or objet=".sql_quote('id_'.$objet).")");
	while($row = sql_fetch($res)) $result[] = $row['uri'];
	return $result;
}

// get all URLs from dictionary from a specific tempalte
function get_urls_from_template($skel){
	$result = array();
	$res = sql_select("uri", "refresher_urls", "squelette=".sql_quote($id_objet));
	while($row = sql_fetch($res)) $result[] = $row['uri'];
	return $result;
}

// get all template names from dictionary
function refresher_get_templates($rien = ''){
	$result = array();
	$res = sql_select("distinct squelette", "refresher_urls", "", "", "squelette");
	while($row = sql_fetch($res)) $result[] = $row['squelette'];
	return $result;
}

// get all object names from dictionary
function refresher_get_objects($rien = ''){
	$result = array();
	$res = sql_select("distinct objet", "refresher_urls", "", "", "objet");
	while($row = sql_fetch($res)) $result[] = $row['objet'];
	return $result;
}

// add to array urls of an object from dictionary
function add_object_urls(&$urls, $id_objet, $objet){
	$urls[_REFRESHER_METHOD] = array_merge($urls[_REFRESHER_METHOD], get_urls_from_object($id_objet, $objet));
}

// useful function to see if an article is already published, 
// if so, we return 1, else we return unix date of publication
// if article's status is not 'published' we return 0
// this will determine if we need to refresh some pages or not
function article_is_published($id_article){
	$res = sql_select("date", "spip_articles", "id_article=".intval($id_article)." and statut='publie'", "", "", 1);
	if($row = sql_fetch($res)){
		$date = $row['date'];
		$date_obj = date_create_from_format('Y-m-d H:i:s', $date);
		$date_tmp = date_format($date_obj, 'U');
		if(time() < $date_tmp) return $date_tmp;
		else return 1; 
	}
	return 0;
}

// function that will remove files from a folder if they were created/modified between 2 dates
function clean_cache_folder($folder, $date_from, $date_to, &$n){
  $files = scandir($folder);
  foreach($files as $key => $value) {
    $path = realpath($folder . DIRECTORY_SEPARATOR . $value);
    if(!is_dir($path)){
    	if(substr($path, -6) == '.cache'){
	    	$file_date = filemtime($path);
				if($file_date > $date_from && $file_date < $date_to){
					@unlink($path);
					$n++;
	  		}
	  	}
    } 
    else if($value != "." && $value != "..") clean_cache_folder($path, $date_from, $date_to, $n);
  }
}

// get links from page content to help crawling the website during warmup
function warmup_find_links($page, &$links){
	//Instantiate the DOMDocument class.
	$htmlDom = new DOMDocument;
	//Parse the HTML of the page using DOMDocument::loadHTML
	@$htmlDom->loadHTML($page);
	//Extract the links from the HTML.
	$links_page = $htmlDom->getElementsByTagName('a'); 
	//Array that will contain our extracted links.
	 
	//Loop through the DOMNodeList.
	//We can do this because the DOMNodeList object is traversable.
	foreach($links_page as $link){
	 
	    //Get the link text.
	    $linkText = $link->nodeValue;
	    //Get the link in the href attribute.
	    $linkHref = $link->getAttribute('href');
	 		//If the link is empty, skip it and don't
	    //add it to our $extractedLinks array
	    if(strlen(trim($linkHref)) == 0){
	        continue;
	    }
	 
	    //Skip if it is a hashtag / anchor link.
	    if($linkHref[0] == '#'){
	        continue;
	    }
	 
	    //Add the link to our $extractedLinks array.
	    $links[] = array(
	        'text' => $linkText,
	        'href' => $linkHref
	    );
	 
	}
}

?>